
#include <X11/Xlib.h>

#include <cni.h>
#include <gnu/gcj/RawData.h>
#include <java/lang/IndexOutOfBoundsException.h>
#include <java/lang/IllegalStateException.h>
#include "no/rwr/x/Display.h"
#include "no/rwr/x/Window.h"
#include "no/rwr/x/XEvent.h"
#include "no/rwr/x/ClientMessageEvent.h"


jint no::rwr::x::ClientMessageEvent::getMessageTypeAtom() {
    ::XClientMessageEvent* evt = (::XClientMessageEvent*) event->structure;
    return evt->message_type;
}

jint no::rwr::x::ClientMessageEvent::getFormat() {
    ::XClientMessageEvent* evt = (::XClientMessageEvent*) event->structure;
    return evt->format;
}

jbyte no::rwr::x::ClientMessageEvent::getByte(jint i) {
    ::XClientMessageEvent* evt = (::XClientMessageEvent*) event->structure;
    if (evt->format != 8) throw new java::lang::IllegalStateException();
    if ((i<0) || (i>=20)) throw new java::lang::IndexOutOfBoundsException();
    return evt->data.b[i];
}

jshort no::rwr::x::ClientMessageEvent::getShort(jint i) {
    ::XClientMessageEvent* evt = (::XClientMessageEvent*) event->structure;
    if (evt->format != 16) throw new java::lang::IllegalStateException();
    if ((i<0) || (i>=10)) throw new java::lang::IndexOutOfBoundsException();
    return evt->data.s[i];
}

jint no::rwr::x::ClientMessageEvent::getInt(jint i) {
    ::XClientMessageEvent* evt = (::XClientMessageEvent*) event->structure;
    if (evt->format != 32) throw new java::lang::IllegalStateException();
    if ((i<0) || (i>=5)) throw new java::lang::IndexOutOfBoundsException();
    return evt->data.l[i];
}

