#include <X11/Xlib.h>
#include <X11/Xutil.h> // for XDestroyImage(...)

#include <cni.h>
#include <gnu/gcj/RawData.h>

#include <java/lang/OutOfMemoryError.h>

#include "no/rwr/x/Display.h"
#include "no/rwr/x/Screen.h"
#include "no/rwr/x/Visual.h"
#include "no/rwr/x/Drawable.h"
#include "no/rwr/x/XImage.h"
#include "no/rwr/x/Pixmap.h"

jint no::rwr::x::Pixmap::createXID(Drawable* drawable,
				   jint width, jint height,
				   jint depth) {
    Display* display = drawable->getDisplay();
    ::Display* dpy = (::Display*) (display->display);
    jint xid = drawable->getXID();

    return XCreatePixmap(dpy, xid, width, height, depth);
}

void no::rwr::x::Pixmap::finalize() {
    ::Display* dpy = (::Display*) (getDisplay()->display);
    XFreePixmap(dpy, getXID());
}
