package no.rwr.xutil;

import no.rwr.x.*;


public class Frame extends TopLevelWindow {

    String title;
    String iconTitle;

    WMSizeHints normalSizeHints;

    public Frame() {
    }


    public void setGroupLeader(TopLevelWindow leader) {
	// ...
    }
    public void setTitle(String title) {
	this.title = title;

	checkTitle();
    }
    private void checkTitle() {
	if (!(valid && mapped)) return;
	if (title == null) return;

	//System.out.println("checkTitle, title="+title);
	Window win = getWindow();
	
	//System.out.println("checkTitle1, win="+win);
	win.setProperty("WM_NAME", "STRING", title);

	title = null;
	//System.out.println("checkTitle2");
    }
    
    public void setIconTitle(String iconTitle) {
	this.iconTitle = iconTitle;

	checkIconTitle();
    }

    private void checkIconTitle() {
	if (!(valid && mapped)) return;
	if (iconTitle == null) return;

	getWindow().setProperty("WM_ICON_NAME", "STRING", iconTitle);
	iconTitle = null;
    }
    

    public void whenMapped() {
	checkTitle();
	checkIconTitle();

	// Call super. Doing this, and doing this last, is very important.
	super.whenMapped();
    }

    public void processClientMessage(ClientMessageEvent message) {
	Display display = getWindow().getDisplay();
	int xa_WM_PROTOCOLS = display.getAtom("WM_PROTOCOLS");
	int xa_WM_DELETE_WINDOW = display.getAtom("WM_DELETE_WINDOW");
	if (message.getMessageTypeAtom() == xa_WM_PROTOCOLS) {
	    int protocolAtom = message.getInt(0);
	    if(protocolAtom == xa_WM_DELETE_WINDOW) {
		System.out.println("WM_DELETE_WINDOW message received,");
		System.out.println(message);
		//FIXME: report
		return;
	    }
	    String protocol = display.getAtomName(protocolAtom);
	    System.err.println("Unknown WM protocol message: " + protocol);
	}

	System.err.println("Unknown client message: " + message);
	super.processClientMessage(message);
    }
}
